using System;
using CoronaVirusGame.GuiGame;
using Microsoft.Xna.Framework;
using MonoGame.Extended;

namespace CoronaVirusGame.ClLauncher
{
    public static class Program
    {
        [STAThread]
        static void Main()
        {
            Level level1 = new Level
            {
                ShelfRectangles = new RectangleF[]
                {
                    new Rectangle(1, 1, 1, 3),
                    new Rectangle(2, 6, 3, 1),
                    new Rectangle(5, 1, 1, 3),
                    new Rectangle(7, 1, 3, 1),
                    new Rectangle(12, 1, 3, 1)
                },
                ToiletPaperSize = new Point2(0.1875f, 0.3125f),
                AiTpPickupCooldown = TimeSpan.FromSeconds(0.2),
                MovementSpeed = 10,
                OpponentCount = 1,
                StartingPos = new Point(1, 1),
                PersonSize = new Point2(1.5f, 1),
                ToiletPaperPerShelf = 10,
                TimeLimit = TimeSpan.FromMinutes(1)
            };
            Level level2 = new Level
            {
                ShelfRectangles = new RectangleF[]
                {
                    new RectangleF(1, 0.5f, 0.5f, 1.5f),
                    new RectangleF(3.5f, 0.5f, 0.5f, 1.5f),
                    new RectangleF(1, 2.5f, 0.5f, 1.5f),
                    new RectangleF(3.5f, 2.5f, 0.5f, 1.5f),
                    new RectangleF(1.5f, 4.5f, 1.5f, 0.5f),
                    new RectangleF(1.5f, 7.5f, 1.5f, 0.5f),
                    new RectangleF(5.5f, 1, 1.5f, 0.5f),
                    new RectangleF(5.5f, 4.5f, 0.5f, 1.5f),
                    new RectangleF(8, 3, 0.5f, 1.5f),
                    //new RectangleF(10, 11, 1.5f, 0.5f),
                    new RectangleF(5, 1, 0.5f, 1.5f),
                    new RectangleF(10, 5, 1.5f, 0.5f),
                    new RectangleF(14, 2, 0.5f, 1.5f)
                },
                ToiletPaperSize = new Point2(0.09375f, 0.15625f),
                AiTpPickupCooldown = TimeSpan.FromSeconds(0.2),
                MovementSpeed = 5,
                OpponentCount = 5,
                RandomStartingPos = true,
                PersonSize = new Point2(0.75f, 0.5f),
                ToiletPaperPerShelf = 10,
                TimeLimit = TimeSpan.FromMinutes(1.5f),
                Checkout = new RectangleF(13, 5, 1, 1.5f),
                RestockerSize = new Point2(0.5f, 0.5f),
                Restockers = 5
            };
            using (var game = new GuiGameDisplay(level2, new Point(1280, 720)))
                game.Run();
        }
    }
}
