using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace CoronaVirusGame.GuiGame
{
    public class Checkout : Selectable
    {
        public Rectangle DrawRectangle;
        public Texture2D Texture;
        public Checkout(Rectangle drawRectangle)
        {
            DrawRectangle = drawRectangle;
            SelectionRange = DrawRectangle;
        }
        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(Texture, DrawRectangle, Color.White);
        }
        public void SellToiletPaper(Person person)
        {
            if (person.ToiletPaperCount == 0)
                return;
            int scoreAchieved = (int)person.ToiletPaperCount * 5;
            person.Score += scoreAchieved;
            person.ResetToiletPaper();
        }
    }
}