using System;
using System.Linq;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using MonoGame.Extended.Input;
using MonoGame.Extended;

namespace CoronaVirusGame.GuiGame
{
    public class Player : Person
    {
        public Player(Texture2D texture, Texture2D tpTexture, Vector2 initialPosistion, Point2 size, float movementSpeed, Point tpSize)
        {
            base.Texture = texture;
            base.TpTexture = tpTexture;
            base.Posistion = initialPosistion;
            base.PersonSize = size;
            base.MovementSpeed = movementSpeed;
            base.TpSize = tpSize;
        }
        private Shelf GetSelectedShelf(List<Shelf> shelves)
        {
            List<(int amount, Shelf shelf)> selectables = new List<(int amount, Shelf shelf)>();
            foreach (Shelf shelf in shelves)
            {
                Rectangle personRectangle = Rectangle;
                bool selectable = shelf.IsSelectable(personRectangle, out int intersectAmount);
                if (selectable)
                    selectables.Add((intersectAmount, shelf));
            }
            if (selectables.Count == 0)
                return null;
            int toSelect = selectables.Max(s => s.amount);
            return selectables.First(s => s.amount == toSelect).shelf;
        }
        public override void Update(GameTime gameTime, GuiGameDisplay game)
        {
            Shelf selectedShelf = GetSelectedShelf(game.Shelves);
            game.SelectedShelf = selectedShelf;
            //TODO: We can eventually have a proper system for controls. This will do for now
            KeyboardStateExtended kState = KeyboardExtended.GetState();
            if (kState.IsKeyDown(Keys.Up))
                MoveForward(MovementSpeed, gameTime);
            float rotationAmount = 2.5f;
            if (kState.IsKeyDown(Keys.Right))
                Rotation += rotationAmount * (float)gameTime.ElapsedGameTime.TotalSeconds;
            if (kState.IsKeyDown(Keys.Left))
                Rotation -= rotationAmount * (float)gameTime.ElapsedGameTime.TotalSeconds;
            if (kState.IsKeyDown(Keys.X) && kState.WasKeyJustUp(Keys.X))
            {
                if (selectedShelf != null && selectedShelf.ToiletPaperCount != 0 && selectedShelf.Accessable)
                {
                    try
                    {
                        AddToiletPaper();
                        selectedShelf.ToiletPaperCount--;
                    }
                    catch (ArgumentException)
                    {
                        //TODO: Handle
                    }
                }
            }
        }
    }
}